/* file.c */

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "main.h"
#include "lib.h"

void load_rc()
{
   char* temp = NULL;
   char* p;
   char* temp2 = NULL;
   FILE *f;
   char* new_row[] = { NULL, NULL, NULL, NULL };
   gint clist_row = -1;
   GList *sp, *np, *mp, *lp;
   char *tmp_bd = NULL;
   int bn = 1;

   temp = safe_malloc(SHORT_STRING);
   if ((f = fopen (dcuprc_path, "r")) != 0)
   {
      while( fgets (temp, SHORT_STRING, f) != NULL)
      {
         p = strchr(temp, ':');
         if (!p)
           continue;
         else
         {
	    *p++ = '\0';
            *(p+strlen(p)-1) = '\0';

            if ( !strcmp(temp, "board") )
	      {
		 temp2 = safe_strdup(p);
		 boards = g_list_append( boards, temp2 );
	      }
	    
	    else if ( !strcmp(temp, "server") )
	      {
		 temp2 = safe_strdup(p);
		 servers = g_list_append( servers, temp2 );
	      }

	    else if ( !strcmp(temp, "name") )
	      {
		 temp2 = safe_strdup(p);
		 names = g_list_append( names, temp2 );
	      }
	    
	    else if ( !strcmp(temp, "mail") )
	      {
		 temp2 = safe_strdup(p);
		 mails = g_list_append( mails, temp2 );
	      }
	    
            else if ( !strcmp(temp, "use_proxy") )
            {
               use_proxy = atoi(p);
            }

            else if ( !strcmp(temp, "proxyserver") )
            {
               proxyserver = safe_strdup(p);
            }
            
	    else if (!strcmp(temp, "proxyport"))
            {
               proxyport = safe_strdup(p);
            }
	 }
      }
      fclose(f);
   }

  lp = boards;
  sp = servers;
  np = names;
  mp = mails;
  while (sp != NULL)
     {
	gtk_clist_append( GTK_CLIST(clist), new_row );
	++clist_row;
	gtk_clist_set_text( GTK_CLIST(clist), clist_row, 1, sp->data );
	if ( lp != NULL )
	  {
	     gtk_clist_set_text( GTK_CLIST(clist), clist_row, 0, lp->data );
	     lp = lp->next;
	  }
	else
	  {
	     tmp_bd = safe_malloc(SHORT_STRING);
	     sprintf(tmp_bd, "Ǽ%d", bn);
	     boards = g_list_append( boards, tmp_bd );
	     gtk_clist_set_text( GTK_CLIST(clist), clist_row, 0, tmp_bd);
	     bn++;
	  }
	if ( np != NULL )
	  {
	     gtk_clist_set_text( GTK_CLIST(clist), clist_row, 2, np->data );
	     np = np->next;
	  }
	else
	  {
	     gtk_clist_set_text(GTK_CLIST(clist), clist_row, 2, names->data);
	  }
	if ( mp != NULL )
	  {
	     gtk_clist_set_text( GTK_CLIST(clist), clist_row, 3, mp->data );
	     mp = mp->next;
	  }
	else
	  {
	     gtk_clist_set_text(GTK_CLIST(clist), clist_row, 3, mails->data);
	  }
	sp = sp->next;
     }

  np = names;
  while (np != NULL)
     {
	lp = np->next;
	while (lp != NULL)
	  {
	     if (strcmp(np->data, lp->data) == 0)
	       {
		  sp = lp->next;
		  g_list_remove(names, lp->data);
		  lp = sp;
	       }
	     else
	       {
		  lp = lp->next;
	       }
	  }
	np = np->next;
     }

  safe_free((void **)&temp);

  if ( clist_row == -1 )
     {
	boards = g_list_append(boards, "Ǽ");
	gtk_clist_append( GTK_CLIST(clist), new_row );
        gtk_clist_set_text( GTK_CLIST(clist), 0, 0, "Ǽ" );
	gtk_clist_set_text( GTK_CLIST(clist), 0, 1, "http://kondara.sdri.co.jp/bbs/kondara.html" );
     }
}


void save_rc()
{
   char *temp;
   gchar *p;
   FILE *f;
   int row = 0;
   
   if ((f = fopen (dcuprc_path, "w")) != 0)
   {

      temp = safe_malloc(SHORT_STRING);
      
      while ( gtk_clist_get_text( GTK_CLIST(clist), row, 0, &p ) )
	{
	   sprintf( temp, "board:%s\n", p );
	   fputs( temp, f );

	   if ( gtk_clist_get_text( GTK_CLIST(clist), row, 1, &p ) )
	     {
		sprintf( temp, "server:%s\n", p );
		fputs( temp, f );
	     }
	   
	   if ( gtk_clist_get_text( GTK_CLIST(clist), row, 2, &p ) )
	     {
		sprintf( temp, "name:%s\n", p );
		fputs( temp, f );
	     }
	   if ( gtk_clist_get_text( GTK_CLIST(clist), row, 3, &p ) )
	     {
		sprintf( temp, "mail:%s\n", p );
		fputs( temp, f );
	     }
	   row++;
	}

      sprintf( temp, "use_proxy:%d\n", use_proxy );
      fputs( temp, f );

      if ((proxyserver != NULL) && (*proxyserver != '\0'))
	{
	   sprintf( temp, "proxyserver:%s\n", proxyserver );
	   fputs( temp, f );
	   sprintf( temp, "proxyport:%s\n", proxyport );
	   fputs( temp, f );
	}

      safe_free((void **)&temp);
      fclose(f);
   }
}
 
