/***************************************************************
 * config.h
 * 
 * config_dialog() ... configure dialog for all dcup parameters
 * 
 * 
 * 
*/

#ifndef __CONFIG_H__
#define __CONFIG_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

int config();

void button_add_clicked( GtkWidget *button, gpointer data);
void button_edit_clicked( GtkWidget *button, gpointer data);
void button_del_clicked( GtkWidget *button, gpointer data);
void button_clear_clicked( GtkWidget *button, gpointer data);

void selection_made( GtkWidget *clist, gint row, gint column,
		    GdkEventButton *event);
void selection_delete( GtkWidget *clist, gint row, gint column,
		     GdkEventButton *event);
void main_buttons_clicked( GtkWidget* button, gint* ret );
void delete_request( GtkWidget* window, gint* ret );
void copy_clist( GtkWidget* _clist_dest, GtkWidget* _clist_src );
   
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __CONFIG_H__ */
