/* dialog.h */

#ifndef __dialog_box_H__
#define __dialog_box_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define MODAL

struct entrydlg {
  gint ret_val;
  gchar *ret_str;
};

struct proxydlg {
  gint ret_val;
  gchar *servername;
  gchar *portno;
};

gint alert_dialog(const char *labelString,
 		  char *button1, 
 		  char *button2, 
 		  char *button3
 		  );

void alert_click (GtkWidget *widget, gpointer value);

gint entry_dialog(const char *labelString,
 		  char *button1, 
 		  char *button2, 
 		  char *string
 		  );

void entry_click (GtkWidget *widget, gpointer value);

gint proxy_dialog(char *serverno,
 		  char *portno
 		  );

void proxy_click (GtkWidget *widget, gpointer value);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __dialog_box_H__ */
